variables:
  GIT_SUBMODULE_STRATEGY: recursive

stages:
  - test
  - release

.check:
  stage: test
  image: cr.yandex/crpkun66rq02t8mpkpa4/cpp-course-build
  allow_failure: true
  script:
    - cmake --version
    - mkdir -p build/solutions
    - cd build/solutions
    - cmake ../../ -G Ninja -DTEST_SOLUTION=ON -DENABLE_PRIVATE_TESTS=ON
    - ninja test-all

check-solutions-clang-11:
  extends: .check
  variables:
    CC: clang-11
    CXX: clang++-11

deploy:
  tags:
  - docker
  stage: release
  script:
  - docker pull cr.yandex/crpkun66rq02t8mpkpa4/cpp-course-build
  - docker build -f testenv.docker -t cr.yandex/crpkun66rq02t8mpkpa4/cpp-course-beta .
  - docker push cr.yandex/crpkun66rq02t8mpkpa4/cpp-course-beta:latest
